package com.giderosmobile.android;

import java.lang.reflect.Field;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.res.Configuration;
import android.opengl.GLSurfaceView;
import android.os.Bundle;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.widget.FrameLayout;

import com.giderosmobile.android.player.GiderosApplication;
import com.giderosmobile.android.player.WeakActivityHolder;
import com.google.ads.AdRequest;
import com.google.ads.AdSize;
import com.google.ads.AdView;
import com.streetpool.R;
import com.nightspade.gideros.android.plugins.chartboost.GChartBoost;
public class StreetPoolActivity extends Activity implements OnTouchListener
{
	static
	{
		System.loadLibrary("gideros");
		System.loadLibrary("luasocket");
		System.loadLibrary("lfs");
		System.loadLibrary("ggooglebilling");
		System.loadLibrary("chartboost");

	}

	static private String[] externalClasses = {
		"com.giderosmobile.android.plugins.googlebilling.GGoogleBilling",
		"com.nightspade.gideros.android.plugins.chartboost.GChartBoost"
	};
	
	private GLSurfaceView mGLView;
	private AdView adView;

	private boolean mHasFocus = false;
	private boolean mPlaying = false;
		
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
				
		 mGLView = new GiderosGLSurfaceView(this);
			//setContentView(mGLView);
			    //set new main layout
			 setContentView(R.layout.main);
			mGLView.setOnTouchListener(this);
			
			WeakActivityHolder.set(this);

			GiderosApplication.onCreate(externalClasses);
		Configuration conf = getResources().getConfiguration();
		int screenLayout = 1; // application default behavior
		try {
		    Field field = conf.getClass().getDeclaredField("screenLayout");
		    screenLayout = field.getInt(conf);
		} catch (Exception e) {
		    // NoSuchFieldException or related stuff
		}

		// Configuration.SCREENLAYOUT_SIZE_MASK == 15
		int screenType = screenLayout & 15;

		// Configuration.SCREENLAYOUT_SIZE_SMALL == 1
		// Configuration.SCREENLAYOUT_SIZE_NORMAL == 2
		// Configuration.SCREENLAYOUT_SIZE_LARGE == 3
		// Configuration.SCREENLAYOUT_SIZE_XLARGE == 4

		if (screenType == 1) {// Create the adView with your publisher ID
			adView = new AdView(this, AdSize.BANNER,  "a14fd0735f79b95");

			//get main layout
			FrameLayout layout = (FrameLayout)findViewById(R.id.layout_main);
			     
			//this can be used to change position of advertisement
			//change Gravity.TOP to Gravity.BOTTOM if you want ads to appear in the bottom
			    FrameLayout.LayoutParams adParams = new FrameLayout.LayoutParams(
			                FrameLayout.LayoutParams.WRAP_CONTENT ,
			                FrameLayout.LayoutParams.WRAP_CONTENT ,
			                Gravity.BOTTOM);

			// Add the Gideros view to main layout
			layout.addView(mGLView);
			// Add the adView to main layout
			layout.addView(adView, adParams);
			adView.loadAd(new AdRequest());
		   
		} else if (screenType == 2) {// Create the adView with your publisher ID
			adView = new AdView(this, AdSize.BANNER,  "a14fd0735f79b95");

			//get main layout
			FrameLayout layout = (FrameLayout)findViewById(R.id.layout_main);
			     
			//this can be used to change position of advertisement
			//change Gravity.TOP to Gravity.BOTTOM if you want ads to appear in the bottom
			    FrameLayout.LayoutParams adParams = new FrameLayout.LayoutParams(
			                FrameLayout.LayoutParams.WRAP_CONTENT ,
			                FrameLayout.LayoutParams.WRAP_CONTENT ,
			                Gravity.BOTTOM);

			// Add the Gideros view to main layout
			layout.addView(mGLView);
			// Add the adView to main layout
			layout.addView(adView, adParams);
			adView.loadAd(new AdRequest());
		   
		} else if (screenType == 3) {// Create the adView with your publisher ID
			adView = new AdView(this, AdSize.IAB_LEADERBOARD,  "a14fd0735f79b95");

			//get main layout
			FrameLayout layout = (FrameLayout)findViewById(R.id.layout_main);
			     
			//this can be used to change position of advertisement
			//change Gravity.TOP to Gravity.BOTTOM if you want ads to appear in the bottom
			    FrameLayout.LayoutParams adParams = new FrameLayout.LayoutParams(
			                FrameLayout.LayoutParams.WRAP_CONTENT ,
			                FrameLayout.LayoutParams.WRAP_CONTENT ,
			                Gravity.BOTTOM);

			// Add the Gideros view to main layout
			layout.addView(mGLView);
			// Add the adView to main layout
			layout.addView(adView, adParams);
			adView.loadAd(new AdRequest());
		  
		} else if (screenType == 4) {// Create the adView with your publisher ID
			adView = new AdView(this, AdSize.IAB_LEADERBOARD,  "a14fd0735f79b95");

			//get main layout
			FrameLayout layout = (FrameLayout)findViewById(R.id.layout_main);
			     
			//this can be used to change position of advertisement
			//change Gravity.TOP to Gravity.BOTTOM if you want ads to appear in the bottom
			    FrameLayout.LayoutParams adParams = new FrameLayout.LayoutParams(
			                FrameLayout.LayoutParams.WRAP_CONTENT ,
			                FrameLayout.LayoutParams.WRAP_CONTENT ,
			                Gravity.BOTTOM);

			// Add the Gideros view to main layout
			layout.addView(mGLView);
			// Add the adView to main layout
			layout.addView(adView, adParams);
			adView.loadAd(new AdRequest());
		  
		} else {// Create the adView with your publisher ID
			adView = new AdView(this, AdSize.BANNER,  "a14fd0735f79b95");

			//get main layout
			FrameLayout layout = (FrameLayout)findViewById(R.id.layout_main);
			     
			//this can be used to change position of advertisement
			//change Gravity.TOP to Gravity.BOTTOM if you want ads to appear in the bottom
			    FrameLayout.LayoutParams adParams = new FrameLayout.LayoutParams(
			                FrameLayout.LayoutParams.WRAP_CONTENT ,
			                FrameLayout.LayoutParams.WRAP_CONTENT ,
			                Gravity.BOTTOM);

			// Add the Gideros view to main layout
			layout.addView(mGLView);
			// Add the adView to main layout
			layout.addView(adView, adParams);
			adView.loadAd(new AdRequest());

		}     
	}

	int[] id = new int[256];
	int[] x = new int[256];
	int[] y = new int[256];

	@Override
	public void onStart()
	{
		super.onStart();
		GiderosApplication.getInstance().onStart();
	}

	@Override
	public void onRestart()
	{
		super.onRestart();
		GiderosApplication.getInstance().onRestart();
	}

	@Override
	public void onStop()
	{
		GiderosApplication.getInstance().onStop();
		super.onStop();
	}

	@Override
	public void onDestroy()
	{ if (adView != null) {
        adView.destroy();}
		GiderosApplication.onDestroy();
		super.onDestroy();
	}

	@Override
	protected void onPause()
	{
		if (mPlaying == true)
		{
			GiderosApplication.getInstance().onPause();
			mGLView.onPause();
			mPlaying = false;
		}
		
		super.onPause();
	}

	@Override
	protected void onResume()
	{
		super.onResume();

		if (mHasFocus == true && mPlaying == false)
		{
			mGLView.onResume();
			GiderosApplication.getInstance().onResume();
			mPlaying = true;
		}
	}
	
	@Override
	public void onLowMemory()
	{
		super.onLowMemory();
		GiderosApplication.getInstance().onLowMemory();
	}
	 
	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data)
	{
		super.onActivityResult(requestCode, resultCode, data);
		GiderosApplication.getInstance().onActivityResult(requestCode, resultCode, data);
	}
	
	@Override
	public void onWindowFocusChanged(boolean hasFocus)
	{
		super.onWindowFocusChanged(hasFocus);
		
		mHasFocus = hasFocus;

		if (mHasFocus == true && mPlaying == false)
		{
			mGLView.onResume();
			GiderosApplication.getInstance().onResume();
			mPlaying = true;
		}
	}
	
	public boolean onTouch(View v, MotionEvent event)
	{
		int size = event.getPointerCount();
		for (int i = 0; i < size; i++)
		{
			id[i] = event.getPointerId(i);
			x[i] = (int) event.getX(i);
			y[i] = (int) event.getY(i);
		}

		int actionMasked = event.getActionMasked();
		boolean isPointer = (actionMasked == MotionEvent.ACTION_POINTER_DOWN || actionMasked == MotionEvent.ACTION_POINTER_UP);
		int actionIndex = isPointer ? event.getActionIndex() : 0;
				
		if (actionMasked == MotionEvent.ACTION_DOWN || actionMasked == MotionEvent.ACTION_POINTER_DOWN)
		{
			GiderosApplication.getInstance().onTouchesBegin(size, id, x, y, actionIndex);
		} else if (actionMasked == MotionEvent.ACTION_MOVE)
		{
			GiderosApplication.getInstance().onTouchesMove(size, id, x, y);
		} else if (actionMasked == MotionEvent.ACTION_UP || actionMasked == MotionEvent.ACTION_POINTER_UP)
		{
			GiderosApplication.getInstance().onTouchesEnd(size, id, x, y, actionIndex);
		} else if (actionMasked == MotionEvent.ACTION_CANCEL)
		{
			GiderosApplication.getInstance().onTouchesCancel(size, id, x, y);
		}

		return true;
	}

	@Override
    public boolean onKeyDown(int keyCode, KeyEvent event)
    {
		if (GiderosApplication.getInstance().onKeyDown(keyCode, event) == true)
			return true;
		
		return super.onKeyDown(keyCode, event);
    }

	
	@Override
  public boolean onKeyUp(int keyCode, KeyEvent event)
   {
		if (GiderosApplication.getInstance().onKeyUp(keyCode, event) == true)
		return true;
		
	return super.onKeyUp(keyCode, event);
   }
	
	//@Override
//	public boolean onKeyUp(int keyCode, KeyEvent event)
	
	//{
	//if(GChartBoost.onKeyUp(keyCode, event) == true)
	//return true;
	//if (GiderosApplication.getInstance().onKeyUp(keyCode, event) == true)
	//return true;
	//return super.onKeyUp(keyCode, event);
	//} 


}

class GiderosGLSurfaceView extends GLSurfaceView
{
	public GiderosGLSurfaceView(Context context)
	{
		super(context);
		mRenderer = new GiderosRenderer();
		setRenderer(mRenderer);
	}

	GiderosRenderer mRenderer;
}

class GiderosRenderer implements GLSurfaceView.Renderer
{
	public void onSurfaceCreated(GL10 gl, EGLConfig config)
	{
		GiderosApplication.getInstance().onSurfaceCreated();
	}

	public void onSurfaceChanged(GL10 gl, int w, int h)
	{
		GiderosApplication.getInstance().onSurfaceChanged(w, h);
	}

	public void onDrawFrame(GL10 gl)
	{
		GiderosApplication.getInstance().onDrawFrame();
	}
}
